<template>
  <div class="rui-tag">
    <div v-for="(nibble, index) in nibbles" :key="index" class="rui-tag__segment">{{ nibble||'?' }}</div>
    <rui-button v-if="removable"
                icon="x-bold"
                variant="destructive"
                class="rui-tag__delete-button"
                @click="remove" />
  </div>
</template>

<script>
import RuiButton from '../../Button/Button.vue'

/**
 * Displays a tag.
 *
 * This component handles composed tags, "a la Gitlab": a tag with `::` separators will be displayed as one tag with
 * multiple segments.
 *
 * @preset default { "props": { "tag": "a tag" } }
 * @preset one_segment { "props": { "tag": "blue::true" } }
 * @preset two_segments { "props": { "tag": "a::composed::tag" } }
 * @preset three_segments { "props": { "tag": "a::super::composed::tag" } }
 */
export default {
  name: 'RuiTag',
  emits: [
    'remove',
  ],
  components: { RuiButton },
  props: {
    /** Tag name */
    tag: { required: true, type: String },
    /** Alternative value which will be emitted on remove */
    value: { required: false, type: [String, Number], default: null },
    /** Whether to display a "remove" button next to the tag */
    removable: { required: false, type: Boolean, default: false },
  },
  computed: {
    nibbles () { return this.tag.split('::') },
  },
  methods: {
    remove () {
      const value = this.$props.value || this.$props.tag
      this.$emit('remove', value)
    },
  },
}
</script>
